<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008-2009 Franz Holzinger <franz@ttproducts.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Part of the tt_products (Shop System) extension.
 *
 * functions for the taxes
 *
 * @author	Franz Holzinger <franz@ttproducts.de>
 * @maintainer	Franz Holzinger <franz@ttproducts.de>
 * @package TYPO3
 * @subpackage tt_products
 *
 */


class tx_ttproducts_field_tax extends tx_ttproducts_field_base {
	protected $bUseStaticTaxes = FALSE;

	/**
	 *
	 */
	public function init($cObj, $bUseStaticTaxes, $uidStore)	{
		global $TYPO3_DB,$TSFE,$TCA;

		parent::init($cObj);

		if ($bUseStaticTaxes && $uidStore)	{
			$tablesObj = t3lib_div::getUserObj('&tx_ttproducts_tables');
			$staticTaxObj = $tablesObj->get('static_taxes', FALSE);
/*			$dummyRow = array('tax_id' => '1');*/
			$staticTaxObj->setStoreData($uidStore);
			if ($staticTaxObj->isValid())	{
				$this->bUseStaticTaxes = TRUE;
			}
		}
	} // init

	public function getUseStaticTaxes ()	{
		return $this->bUseStaticTaxes;
	}

	public function getTax (&$row)	{
		$rc = $this->getFieldValue ($row, 'tax');
		return $rc;
	}

	public function getFieldValue ($row, $fieldname)	{
		$newTax = '';

		if ($this->getUseStaticTaxes())	{
			$taxArray = array();
			$tablesObj = t3lib_div::getUserObj('&tx_ttproducts_tables');
			$staticTaxObj = $tablesObj->get('static_taxes', FALSE);
			$staticTaxObj->getStaticTax($row, $newTax, $taxArray);
		}

		if (is_float($newTax))	{
			$fieldValue = $newTax;
		} else {
			$fieldValue = parent::getFieldValue($row, $fieldname);

			if (!floatval($fieldValue))	{
				if ($this->conf['TAXpercentage'])	{
					$fieldValue = floatval($this->conf['TAXpercentage']);
				} else {
					$fieldValue = 0.0;
				}
			}
		}
		return $fieldValue;
	}
}


if (defined('TYPO3_MODE') && $GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/tt_products/model/field/class.tx_ttproducts_field_tax.php'])	{
	include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/tt_products/model/field/class.tx_ttproducts_field_tax.php']);
}

?>